.device ATtiny15
.include "C:\Program Files\Atmel\AVR Tools\AvrAssembler\Appnotes\tn15def.inc"
.def temp=r16;
.def counter=r17;
.def tempi=r18;
.def logic=r19;
.def time=r20;
.def flag=r21;

rjmp Reset;
reti; EXT_INT0
reti; PIN_CHANGE
reti; TIM1_CMP
reti; TIM1_OVF
rjmp STEEP; TIM0_OVF
reti; EE_RDY
reti; ANA_COMP
reti; ADC


Reset:
	ldi temp,0x27;
	out DDRB,temp;
	ldi temp,0x7E;
	out OCR1A,temp;
	clr ZL;
	clr ZH; 
	st Z+,r29;
	cpi ZL,29;
	brne PC-2;
	ldi logic,0x18;
	clr ZL;
	ldi temp,0x02;
	out TIMSK,temp;
Start:
	in temp,PortB;
	and temp,logic;
	cpi temp,8;
	breq PC+5;
	cpi temp,24;
	breq PC+5;
	cpi temp,0;
	breq PC+5;
	rcall ON_1;
	rjmp Start;
	rcall ON_2;
	rjmp Start;
	rcall OFF;
	rjmp Start;
	
STEEP: 
	in tempi,SREG;
	cpi time,45;
	breq PC+3;
	inc time;
	reti;
	clr time;
	brts PC+8;		       
	in counter,OCR1A;	    
	cpi counter,230;
	breq PC+3;
	inc counter;
	out OCR1A,counter;
	out SREG,tempi;
	reti;
	in counter,OCR1A;	  
	cpi counter,126;
	breq PC+3;
	dec counter;
	out OCR1A,counter;
	out SREG,tempi;
	reti;
ON_1:
	cpi flag,3;
	breq PC+7;
	cpi flag,1;
	breq PC+4;
	inc flag;
	ldi temp,0x6b;
	out TCCR1,temp;
	ret;
	in temp,OCR1A;
	cpi temp,126;
	breq PC+4;
	brts PC+2;
	set;
	ret;
	cli;
	ldi flag,0x01;
	clr temp;
	out TCCR0,temp;
	out TCNT0,temp;
	clr time;
	ret;

ON_2:	
	clt;
	cpi flag,3;
	breq PC+5;
	subi flag,-2;
	ldi temp,0x05;
	out TCCR0,temp;
	sei;
	ret;

OFF:
	cpi flag,0;
	breq PC+11;
	clr flag;
	cli;
	out TCCR0,flag;
	out TCCR1,flag;
	out TCNT0,flag;
	out TCNT1,flag;
	ldi temp,126;
	out OCR1A,temp;
	clt;
	clr time;
	ret;
	
	
